Copyright (C) 2007-2021 Sergey Poznyakoff

   Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.3 or
any later version published by the Free Software Foundation; with no
Invariant Sections, with the Front-Cover texts being "Wyslij-po Manual",
and with the Back-Cover Texts as in (a) below.  A copy of the license is
included in the section entitled "GNU Free Documentation License".

   (a) The FSF's Back-Cover Text is: "You have freedom to copy and
modify this Manual, like GNU software.  Help the software be free."

Wyslij-po
*********

This edition of the 'Wyslij-po Manual', last updated 8 February 2021,
documents Wyslij-po Version 3.3.

1 Introduction to Wyslij-po
***************************

It is a common practice for a program to be documented and to produce
its diagnostics in English.  However, the waste majority of us would
prefer their computer to speak our native language instead.  This goal
is already achieved for many free software programs, and is going to be
achieved for still more of them using the methods called
"internationalization" and "localization".  These terms are often
written abbreviated as "i18n" and "l10n", correspondingly.  In short,
"i18n" consists in modifying a program in such a way that, while still
producing its output in English, it would allow this output to be
translated to any given language on the fly.  Similarly, "l10n" consists
in supplying an already internationalized program enough information for
it to be able to translate its output to a particular language.  Both
terms are discussed in further detail in I18n (gettext).

   While internationalization is usually taken care of by programmers,
localization is the responsibility of translators.  Usually this process
consists of creating a special file, called "PO file", which is
basically a table of all the messages the program ever issues, which,
for each such message, lists its translation to a given language (see
The Format of PO Files (gettext)).

   When translator finishes writing a PO file, he submits it via
electronic mail to the "free Translation Project"
(<http://translationproject.org>), or TP for short, which acts as a
repository for the existing translations.  It is from the Translation
Project that maintainers download PO files for inclusion into their
projects, when preparing them for the release.

   There are several ways to submit a translation.  First, it can, of
course, be submitted manually.  Secondly, you can use the 'M'
('po-send-mail') command in GNU Emacs "po-mode" (see The Format of PO Files (gettext)).
Finally, you can use some specialized
program to do that.

   If you choose the last possibility, 'wyslij-po' is for you.  It is a
specialized program which verifies PO files and submits them to the TP.

   The program name(1) means 'send-po' in Polish and is pronounced
roughly like 'vishleey-po'.

   The program is built using GNU Mailutils
(http://www.gnu.org/software/mailutils) -- a powerful collection of
libraries and utilities for handling electronic mail.

   ---------- Footnotes ----------

   (1) It should more properly have been written 'wyślij-po'.

2 Submitting Translations.
**************************

To submit one or several PO files, simply give them as arguments to
'wyslij-po' in the command line, like this:

     $ wyslij-po pl.po uk.po bg.po

   For each file, specified in the command line, the utility will do the
following steps:

  1. Retrieve PO headers

     PO headers contain important information about the translation.
     These headers are stored in the first entry of each PO file.

  2. Restore canonical PO name.

     A canonical PO name consists of the project name and version,
     separated by dash, which are followed by a dot, the language code
     as per ISO 639, and the suffix '.po'.  To determine the canonical
     name, 'wyslij-po' uses the contents of 'Project-Id-Version' and
     'Language' PO headers.  The value of 'Project-Id-Version' supplies
     the name and version of the project this file is for, and the value
     of 'Language' gives the ISO-639 abbreviation of the language name.
     For example, if the two headers in question were:

          Project-Id-Version: cflow 1.2
          Language: pl

     then the canonical name for that file is 'cflow-1.2.pl.po'.

     If the PO file lacks the 'Language' header, 'wyslij-po' analyzes
     the 'Language-Team' header.  The full language name extracted from
     this header is looked up in a "language table" file to find the
     corresponding ISO-639 code (see Langtab).

  3. Verify the consistency of PO file.

     This step ensures that the file corresponds to the latest version
     of the package in question and that it does not contain obvious
     formatting errors.  For the detailed description of the checks
     performed, see Verification, below.

  4. Form the message to be submitted.

     The message is a MIME 1.0 message, whose body contains the
     compressed PO file, and the headers contain the necessary
     registration information (see Message).

  5. Send the message.

     See Sending, below.

   The following sections describe each step in detail.

2.1 Verification
================

Before constructing a submission message, 'wyslij-po' first verifies if
the PO file in question matches several important conditions.  It is
done in order to reduce the unwanted traffic and the impact on the TP
mail server and robot.

   As of version 3.3, the following tests are implemented:

  1. PO revision date.

     The values of the PO headers 'PO-Revision-Date' and
     'POT-Creation-Date' are compared.  If 'POT-Creation-Date' is newer
     than 'PO-Revision-Date', the PO file is obviously outdated and
     therefore it is not submitted.

     This test is controlled by the following command line options:

     '--verify-po-time'
          Verify PO modification time (default).

     '--no-verify-po-time'
          Disable PO modification time verification.

     In configuration file, this test is controlled by the
     'verify-po-time' boolean statement (see verify-po-time).

  2. Package version

     This test verifies if this PO file is created for the latest
     version of the package available.  To verify this the following
     algorithm is used.  First, the "textual domain url" is built using
     the following schema:

          http://translationproject.org/domain/${domain}.html

     where '${domain}' is replaced with the project name obtained from
     the 'Project-Id-Version' PO header.

     Then, the contents of this page is retrieved, and the following
     extended "regular expression" is applied to it:

          The current template for this domain is <a href=".[^"]*/(.[^"]*)">

     If the expression matches, the value of the first parenthesized
     subexpression is retrieved, the optional '.pot' suffix is removed
     from it and the result is compared with the value of
     'Project-Id-Version' PO header, converted as described in
     canonical-name.  The two strings must be equal in order for the
     test to succeed.

     This test is controlled by the following command line options:

     '--verify-version'
          Enable package version verification (default).

     '--no-verify-version'
          Disable package version verification.

     In configuration file, this test is controlled by the
     'verify-version' boolean statement (see verify-version).

     Two configuration file statements are provided for tuning this
     test.  The 'tp-url' statement changes the textual domain template
     (see tp-url) and the 'pot-regex' statement changes the
     regular expression (see pot-regex).

2.2 Message
===========

The minimal message headers are:

     From: SENDER
     To: ROBOT-ADDRESS
     Subject: TP-Robot CANONICAL-NAME
     X-Mailer: wyslij-po 3.3

   Where:

SENDER
     The email of the sender.  Unless otherwise specified, it is
     constructed by concatenating the actual user name, a '@' sign, and
     the host name of the local host.

     This value can be set explicitly using '--from' ('-F') command line
     option.  When used without additional arguments, as in:

          $ wyslij-po -F pl.po

     this option instructs 'wyslij-po' to extract sender name from the
     value of 'Last-Translator' PO header.  This is equivalent to
     setting 'from-po true' in the configuration file (see from-po).

     This option can also be used with an explicit argument, which
     specifies the email to be used as a sender address.  It is
     important to remember that when the short option form is used, this
     argument must follow the option letter immediately, without any
     intervening whitespace.  If the long option form is used, this
     argument must be delimited from the option name by an equals sign
     with no extra whitespace on either side of it.  The following
     invocations illustrate this:

          wyslij-po -Ftrans@gnu.org.ua
          wyslij-po --from=trans@gnu.org.ua

     This can be requested in configuration file by using 'from'
     statement (see from).

ROBOT-ADDRESS
     The email of the TP robot.  By default it is:

          robot@translationproject.org

     It can be changed using '--to' ('-t') command line option, or 'to'
     configuration statement (see to).

CANONICAL-NAME
     The canonical name of the PO file.  It is determined as described
     in canonical-name.

   Additionally, you can require the message to be copied to any number
of emails by using '--cc' command line option or 'cc' configuration
statement.  In both cases, the argument is a string containing a
comma-separated list of valid email addresses, as in:

     $ wyslij-po --cc "tp-keeper@dom.ain,root@remote.org"

   If you wish to make those additional addresses invisible, use the
'--bcc' command line option (or 'bcc' configuration statement) instead.

   The '--fcc' option specifies the folder to store the copy of the
message into.  Its argument is any "mailbox URL" supported by Mailutils
(see URL (mailutils)). For example, the following option will
place copies of the PO files in the MH folder 'Mail/sent':

     $ wyslij-po --fcc mh://Mail/sent

   In configuration file, this is done via the 'fcc' statement (see
fcc).

   The PO file contents is by default sent in compressed form.  To
produce it, 'gzip' program is used (see Overview (gzip)).
Notice, that the 'gzip' binary must be in your 'PATH', otherwise
'wyslij-po' won't be able to find it.  You can specify the full path to
the binary and/or supply any additional options by using the '--gzip'
('--compress') command line option.  For example, to use '/usr/bin/gzip'
with the highest possible compression level, use:

     $ wyslij-po --gzip "/usr/bin/gzip -c --best"

   Use the 'compress' statement to set the compression command from the
configuration file (see compress).

   Notice, that when setting compression command (either from command
line or from configuration file), _you must always include '-c' option
in the 'gzip' command line_.

2.3 Sending
===========

As any mailutils-based program, 'wyslij-po' uses a special logical
entity called "mailer" in order to actually submit messages.  By default
it uses the MTA facilities of the machine it runs on, so you usually
don't have to explicitly specify which mailer to use.  There may,
however, be some cases when this becomes necessary.  This section
describes how to do so.

   A mailer is specified by its "URL".  An URL begins with a protocol
specification.  Two protocol specifications are currently supported:
'sendmail' and 'smtp'.  The former means to use a 'sendmail'-compatible
program to send mails.  Such a program must be able to read mail from
its standard input and must support the following options:

'-oi'
     Do not treat '.'  as message terminator.

'-f ADDR'
     Use ADDR as the address of the sender.

'-t'
     Get recipient addresses from the message.

   These conditions are met by most existing MTA programs, such as
'exim' or 'postfix' (to say nothing of 'sendmail' itself).

   Following the protocol specification is the "mailer location", which
is separated from it with a colon.  For the 'sendmail' protocol, the
mailer location sets the full file name of the sendmail-compatible MTA
binary, for example:

     sendmail:/usr/sbin/sendmail

   A special form of sendmail URL, consisting of protocol specification
only ('sendmail:') is also allowed.  It means "use the sendmail binary
from the '_PATH_SENDMAIL' macro in your '/usr/include/paths.h' file".
This is the default mailer.

   The 'smtp' protocol means to use an SMTP server directly.  In this
case the mailer location consists of two slashes, followed by the IP
address or host name of the SMTP server, and, optionally, the port
number.  If the port number is present, it is separated from the rest of
URL by a colon.  For example:

     smtp://remote.server.net
     smtp://remote.server.net:24

   The URL of the mailer to use is set using '--mailer' ('-M') command
line option.  For example:

     $ wyslij-po --mailer=smtp://127.0.0.1 pl.po

   An alternative way is to set it in the configuration file, using
'mailer' statement (see Mailer Statement (mailutils)).

   As an example of a rather extreme approach, here is how to deliver
mails directly to the TP mail server:

     $ wyslij-po --mailer=smtp://mail.vrijschrift.org ...

3 Debugging, Verbose Output and Dry-run Mode.
*********************************************

Usually 'wyslij-po' operates silently.  It issues a diagnostics only if
something serious has happened (an error, for example).  You may wish to
change this behavior in order to trace the progress of the submission.

   The '--verbose' command line option instructs the program to increase
its verbosity level.  Each occurrence of this option in the command line
raises the level by one, so to get the verbosity level 3 you would type:

     $ wyslij-po -vvv ...

   The bigger the level, the more information will be produced on the
output.

   Here is an example of the output produced in level 1:

     $ wyslij-po -v pl.po
     pl.po: cflow-1.2.pl.po

     Message headers:
     Content-transfer-encoding: base64
     Content-Type: application/x-gzip; name="cflow-1.2.pl.po.gz"
     MIME-Version: 1.0
     From: trans@gnu.org.ua
     To: robot@translationproject.org
     Subject: TP-Robot cflow-1.2.pl.po
     X-Mailer: wyslij-po 3.3

   Here, the first line shows the input file name and the corresponding
canonical PO name for it.  The remaining lines show RFC 2822 message
headers.

   The verbosity level 2 shows additional information about the
progress:

     $ wyslij-po -vv pl.po
     Sourcing language table `./wyslij-po.lc'
     Restoring canonical file name for `pl.po'
     Verifying POT file version for `mailutils'
     Verifying creation vs. revision date
     pl.po: cflow-1.2.pl.po
     executing gzip -c pl.po...

     Message headers:
     Content-transfer-encoding: base64
     Content-Type: application/x-gzip; name="cflow-1.2.pl.po.gz"
     MIME-Version: 1.0
     From: trans@gnu.org.ua
     To: robot@translationproject.org
     Subject: TP-Robot cflow-1.2.pl.po
     X-Mailer: wyslij-po 3.3

     Submitting pl.po

   The levels 3 and 4 print lots of information concerning actual SMTP
transaction.  These are mainly useful for debugging.

   It is often desirable to know what 'wyslij-po' would do, without
actually sending translations.  The special command line option
'--dry-run' ('-n') is designed for this purpose.  When this option is
given, 'wyslij-po' will do all its usual processing, except for actually
sending the result.  This option automatically sets verbose level to 1
(of course you can push it higher by supplying additional '-v' options
along with '--dry-run'):

     $ wyslij-po --dry-run pl.po
     pl.po: cflow-1.2.pl.po

     Message headers:
     Content-transfer-encoding: base64
     Content-Type: application/x-gzip; name="cflow-1.2.pl.po.gz"
     MIME-Version: 1.0
     From: trans@gnu.org.ua
     To: robot@translationproject.org
     Subject: TP-Robot cflow-1.2.pl.po
     X-Mailer: wyslij-po 3.3

     NOT submitting

4 Configuration Files.
**********************

If you have a set of commonly used 'wyslij-po' options, it is convenient
to keep them in a configuration file, instead of typing them again each
time you invoke the program.  'Wyslij-po' uses the Mailutils concept of
configuration files, which is described in detail in Mailutils Configuration File (mailutils).

   There are two possible locations for the 'wyslij-po' configuration.
System-wide configuration is kept in the main configuration file (see
Main site-wide configuration file (mailutils)), in
section 'program wyslij-po', or in the file named 'wyslij-po' in the
configuration include directory, if the 'include' statement is used
(see Include Statement (mailutils)).  Per-user configuration
is kept in file '~/.wyslij-po'.

   To set default mailer (similar to '--mailer' option, see mailer),
use the 'mailer' statement, see Mailer Statement (mailutils).

 -- Configuration: compress COMMAND
     Set command line of the utility used for file compression.  For
     example:

          compress "/usr/bin/bzip2 -c";

     See gzip, for a detailed discussion of file compression.

     See also -compress, for another way to set this
     value.

 -- Configuration: langtab FILE
     Set the name of the language table file.  See Langtab.

 -- Configuration: to EMAIL
     Set TP robot (recipient) email address.  See Sending.

 -- Configuration: cc EMAIL
     Set emails of carbon copy recipients.  EMAIL may contain multiple
     email addresses, separated by commas:

          cc "<tp@localhost>,<bitbucket@remote.tld>";

     Notice the use of quote characters.

     See also -cc, for another way to set this value.

 -- Configuration: bcc EMAIL
     Set emails of carbon copy recipients.

     See also -bcc, for another way to set this value.

 -- Configuration: fcc FOLDER
     Store a copy of the sent message in the specified mail folder.
     FOLDER can be any valid mailbox URL (see URL (mailutils)).
     The following example instructs 'wyslij-po' to keep copies of the
     messages it sends in a MH folder '+po-out':

          fcc "mh:~/Mail/po-out";

 -- Configuration: from EMAIL
     Set sender e-mail address.  See Message, for a detailed
     description.  See also -from, for another way to set
     this value.

 -- Configuration: from-po BOOL
     Read sender e-mail address from the value of 'Last-Translator' PO
     header.  It is equivalent to specifying the '--from' ('-F') command
     line option without argument.

 -- Configuration: verify-po-time BOOL
     Controls whether to verify PO modification time before sending the
     message.

     See revision date, for a description of this test.

 -- Configuration: verify-version STRING
     Controls whether to verify package version before sending the
     message.

     See Package version, for a description of this
     test.

 -- Configuration: tp-url TEMPLATE
     Sets template for the textual domain URL.  See textual domain url,
     for a description of its purpose.

     TEMPLATE must be a valid HTTP URL.  It must contain at least one
     occurrence of ${domain}, which will be replaced by the actual name
     of the textual domain.

 -- Configuration: pot-regex REGEX
     Set the regular expression matching the name of the last POT file
     for the textual domain.  See regular expression,
     for a detailed description of its purposes.

     REGEX must be an "extended regular expression" (see Extended regular expressions (sed))
     with exactly one
     parenthesized group.

5 Language Tables.
******************

To recreate the canonical PO name (see canonical-name) for a given
translation, 'wyslij-po' needs to know the "language code" associated
with this language.  Normally this information is kept in the 'Language'
header of the PO file(1).  If this header is not present, 'wyslij-po'
will first obtain the full language name from the 'Language-Team' PO
header, and then use this value as a look-up key in a set of "language
tables".  If the key is found, its value gives the language code.

   This language code lookup is retained as a fallback mechanism for
handling old PO files and will be removed in future releases.  This
chapter describes the format of language table files used by
'wyslij-po'.

   The language tables are stored in plain text files.  Their format is
as follows:

   * Empty lines are ignored.
   * Any lines whose first non-whitespace character is '#' are comments
     and are ignored as well.
   * Unless ignored by the above reasons, any line is split at the
     whitespace.  The first word in line gives the language code
     (usually corresponding to ISO 639).  The rest of words is taken as
     a literal string that gives the full language name (the look-up
     key) for that code.

   For example, the following entry:

     pt_BR Brazilian Portuguese

means that when the string 'Brazilian Portuguese' is encountered at the
beginning of the 'Language-Team' PO header, the language code 'pt_BR'
will be used.

   There are two language table files: a "system-wide" and a "per-user"
one.

   The system-wide language table is stored in file 'wyslij-po.lc' in
your system configuration directory (by default it is '/usr/local/etc',
but can be changed at compile time).

   The per-user language table is read after the system-wide one.  It is
located in the user's home directory and is named '.wyslij-po.lc'.  You
can also supply another file name, using the '--langtab' command line
option, e.g.  '--langtab=mytab.lc'.

   The contents of both files are concatenated and stored in a single
table.

   Notice that it is not an error if a language table file does not
exist.  'Wyslij-po' will silently ignore non-existing files.  Therefore,
if you get the similar error:

     wyslij-po: Unknown language: Bulgarian

you should make sure the right tables are read, by running 'wyslij-po'
with the '-vv' (or, better yet, '--dry-run --verbose') command line
option.  In normal case, it will at least read the site-wide language
table, which will be reflected in its output:

     $ wyslij-po --dry-run -v bg.po
     Sourcing language table `/usr/local/etc/wyslij-po.lc'
     Restoring canonical file name for `bg.po'

   If it does not, make sure you install the table or supply its
alternate name using '--langtab'.  Otherwise, inspect the table and add
an entry for the language in question.

   The package is shipped with a system wide configuration file built
using the data from <http://translationproject.org/team>, so most of the
time you won't have to edit it (unless, of course, new language teams
are added to the TP)

   ---------- Footnotes ----------

   (1) The 'Language' header is present in PO files created by 'gettext'
version 0.18 or later.

6 How to Report a Bug
*********************

Email bug reports to <bug-wyslij-po@gnu.org.ua>.

   As the purpose of bug reporting is to improve software, please be
sure to include maximum information when reporting a bug.  The
information needed is:

   * Version of the package you are using.
   * Compilation options used when configuring the package.
   * Conditions under which the bug appears.

Appendix A Downloading wyslij-po
********************************

Stable releases of 'wyslij-po' can be downloaded from
<http://download.gnu.org.ua/pub/release/wyslij-po> (1).

   Each tarball in this directory is GPG signed and the corresponding
signature is available in file with the '.sig' suffix.  To verify the
tarball, be sure to download both the tarball and its signature (e.g.,
for the latest version: 'wyslij-po-3.3.tar.gz' and
'wyslij-po-3.3.tar.gz.sig' ).  Then run a command like this:

     gpg --verify wyslij-po-3.3.tar.gz.sig

   If that command fails because you don't the author's public key, then
run this command to import it:

     gpg --keyserver keys.gnupg.net --recv-keys 3602B07F55D0C732

   A symbolic link to the latest release (and its signature) is
provided:
<http://download.gnu.org.ua/pub/release/wyslij-po/wyslij-po-latest.tar.gz>.

   Pre-release and alpha versions of the package can be downloaded from
<http://download.gnu.org.ua/pub/alpha/wyslij-po>.

   Finally, development of the 'wyslij-po' can be tracked from
<https://puszcza.gnu.org.ua/projects/wyslij-po>.

   ---------- Footnotes ----------

   (1) Traditionally, the 'FTP' protocol is supported as well:
<ftp://download.gnu.org.ua/pub/release/wyslij-po>

Appendix B How to Build the Package
***********************************

Building 'wyslij-po' is quite straightforward:

  1.
     Make sure you have installed the GNU Mailutils, version 3.4 or
     later.

  2.
     Run './configure'

  3.
     Run 'make'

  4.
     Run 'make install'

Appendix C Invocation Summary.
******************************

This appendix lists all 'wyslij-po' command line options.  For each
option are given a short description and a reference to the part of this
manual that fully describes it.

'--bcc=EMAIL-LIST'
     Set blind carbon-copy recipients (see Message).

'--cc=EMAIL-LIST'
     Set carbon-copy recipients (see Message).

'--compress=COMMAND'
'--gzip=COMMAND'
     Use this COMMAND for compression (see Message).

'--dry-run'
'-n'
     Do nothing, print what would have been done (see Dry-run).

'--fcc=FOLDER'
     Store copy of each message sent in the given folder.

'--from[=EMAIL]'
'-FEMAIL'
     Set sender address (see Message).

'--help'
'-?'
     Give a short help summary

'--langtab=FILE'
     Set the name of the per-user language table file (see Langtab).

'--mailer=URL'
'-M URL'
     Use the specified URL as the default mailer.  See Sending.

'--no-verify-po-time'
     Disable PO modification time verification.  See Verification.

'--no-verify-version'
     Disable package version verification.  See Verification.

'--to=EMAIL'
'-t EMAIL'
     Set TP robot (recipient) email address.  See Sending.

'--usage'
     Produce a listing of all command line options.

'--verbose'
'-v'
     Produce verbose output.  See Dry-run.

'--verify-po-time'
     Verify PO modification time.  See Verification.

'--verify-version'
     Make sure the submitted PO file matches the latest package version.
     See Verification.

'--version'
'-V'
     Print program version

                     Version 1.3, 3 November 2008

     Copyright (C) 2000, 2001, 2002, 2007, 2008 Free Software Foundation, Inc.
     <http://fsf.org/>

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     functional and useful document "free" in the sense of freedom: to
     assure everyone the effective freedom to copy and redistribute it,
     with or without modifying it, either commercially or
     noncommercially.  Secondarily, this License preserves for the
     author and publisher a way to get credit for their work, while not
     being considered responsible for modifications made by others.

     This License is a kind of "copyleft", which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.  We
     recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work, in any medium,
     that contains a notice placed by the copyright holder saying it can
     be distributed under the terms of this License.  Such a notice
     grants a world-wide, royalty-free license, unlimited in duration,
     to use that work under the conditions stated herein.  The
     "Document", below, refers to any such manual or work.  Any member
     of the public is a licensee, and is addressed as "you".  You accept
     the license if you copy, modify or distribute the work in a way
     requiring permission under copyright law.

     A "Modified Version" of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A "Secondary Section" is a named appendix or a front-matter section
     of the Document that deals exclusively with the relationship of the
     publishers or authors of the Document to the Document's overall
     subject (or to related matters) and contains nothing that could
     fall directly within that overall subject.  (Thus, if the Document
     is in part a textbook of mathematics, a Secondary Section may not
     explain any mathematics.)  The relationship could be a matter of
     historical connection with the subject or with related matters, or
     of legal, commercial, philosophical, ethical or political position
     regarding them.

     The "Invariant Sections" are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in the
     notice that says that the Document is released under this License.
     If a section does not fit the above definition of Secondary then it
     is not allowed to be designated as Invariant.  The Document may
     contain zero Invariant Sections.  If the Document does not identify
     any Invariant Sections then there are none.

     The "Cover Texts" are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.  A
     Front-Cover Text may be at most 5 words, and a Back-Cover Text may
     be at most 25 words.

     A "Transparent" copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, that is suitable for revising the document
     straightforwardly with generic text editors or (for images composed
     of pixels) generic paint programs or (for drawings) some widely
     available drawing editor, and that is suitable for input to text
     formatters or for automatic translation to a variety of formats
     suitable for input to text formatters.  A copy made in an otherwise
     Transparent file format whose markup, or absence of markup, has
     been arranged to thwart or discourage subsequent modification by
     readers is not Transparent.  An image format is not Transparent if
     used for any substantial amount of text.  A copy that is not
     "Transparent" is called "Opaque".

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and standard-conforming
     simple HTML, PostScript or PDF designed for human modification.
     Examples of transparent image formats include PNG, XCF and JPG.
     Opaque formats include proprietary formats that can be read and
     edited only by proprietary word processors, SGML or XML for which
     the DTD and/or processing tools are not generally available, and
     the machine-generated HTML, PostScript or PDF produced by some word
     processors for output purposes only.

     The "Title Page" means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, "Title
     Page" means the text near the most prominent appearance of the
     work's title, preceding the beginning of the body of the text.

     The "publisher" means any person or entity that distributes copies
     of the Document to the public.

     A section "Entitled XYZ" means a named subunit of the Document
     whose title either is precisely XYZ or contains XYZ in parentheses
     following text that translates XYZ in another language.  (Here XYZ
     stands for a specific section name mentioned below, such as
     "Acknowledgements", "Dedications", "Endorsements", or "History".)
     To "Preserve the Title" of such a section when you modify the
     Document means that it remains a section "Entitled XYZ" according
     to this definition.

     The Document may include Warranty Disclaimers next to the notice
     which states that this License applies to the Document.  These
     Warranty Disclaimers are considered to be included by reference in
     this License, but only as regards disclaiming warranties: any other
     implication that these Warranty Disclaimers may have is void and
     has no effect on the meaning of this License.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow the
     conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies (or copies in media that commonly
     have printed covers) of the Document, numbering more than 100, and
     the Document's license notice requires Cover Texts, you must
     enclose the copies in covers that carry, clearly and legibly, all
     these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the title
     equally prominent and visible.  You may add other material on the
     covers in addition.  Copying with changes limited to the covers, as
     long as they preserve the title of the Document and satisfy these
     conditions, can be treated as verbatim copying in other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a machine-readable
     Transparent copy along with each Opaque copy, or state in or with
     each Opaque copy a computer-network location from which the general
     network-using public has access to download using public-standard
     network protocols a complete Transparent copy of the Document, free
     of added material.  If you use the latter option, you must take
     reasonably prudent steps, when you begin distribution of Opaque
     copies in quantity, to ensure that this Transparent copy will
     remain thus accessible at the stated location until at least one
     year after the last time you distribute an Opaque copy (directly or
     through your agents or retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of copies,
     to give them a chance to provide you with an updated version of the
     Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with the
     Modified Version filling the role of the Document, thus licensing
     distribution and modification of the Modified Version to whoever
     possesses a copy of it.  In addition, you must do these things in
     the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of previous
          versions (which should, if there were any, be listed in the
          History section of the Document).  You may use the same title
          as a previous version if the original publisher of that
          version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has fewer than five), unless they release you
          from this requirement.

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document's
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section Entitled "History", Preserve its Title,
          and add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on the
          Title Page.  If there is no section Entitled "History" in the
          Document, create one stating the title, year, authors, and
          publisher of the Document as given on its Title Page, then add
          an item describing the Modified Version as stated in the
          previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in the
          "History" section.  You may omit a network location for a work
          that was published at least four years before the Document
          itself, or if the original publisher of the version it refers
          to gives permission.

       K. For any section Entitled "Acknowledgements" or "Dedications",
          Preserve the Title of the section, and preserve in the section
          all the substance and tone of each of the contributor
          acknowledgements and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document, unaltered
          in their text and in their titles.  Section numbers or the
          equivalent are not considered part of the section titles.

       M. Delete any section Entitled "Endorsements".  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section to be Entitled
          "Endorsements" or to conflict in title with any Invariant
          Section.

       O. Preserve any Warranty Disclaimers.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option designate
     some or all of these sections as invariant.  To do this, add their
     titles to the list of Invariant Sections in the Modified Version's
     license notice.  These titles must be distinct from any other
     section titles.

     You may add a section Entitled "Endorsements", provided it contains
     nothing but endorsements of your Modified Version by various
     parties--for example, statements of peer review or that the text
     has been approved by an organization as the authoritative
     definition of a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end of
     the list of Cover Texts in the Modified Version.  Only one passage
     of Front-Cover Text and one of Back-Cover Text may be added by (or
     through arrangements made by) any one entity.  If the Document
     already includes a cover text for the same cover, previously added
     by you or by arrangement made by the same entity you are acting on
     behalf of, you may not add another; but you may replace the old
     one, on explicit permission from the previous publisher that added
     the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination all
     of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice, and that you preserve all
     their Warranty Disclaimers.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections Entitled
     "History" in the various original documents, forming one section
     Entitled "History"; likewise combine any sections Entitled
     "Acknowledgements", and any sections Entitled "Dedications".  You
     must delete all sections Entitled "Endorsements."

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the documents
     in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow this
     License in all other respects regarding verbatim copying of that
     document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of a
     storage or distribution medium, is called an "aggregate" if the
     copyright resulting from the compilation is not used to limit the
     legal rights of the compilation's users beyond what the individual
     works permit.  When the Document is included in an aggregate, this
     License does not apply to the other works in the aggregate which
     are not themselves derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one half
     of the entire aggregate, the Document's Cover Texts may be placed
     on covers that bracket the Document within the aggregate, or the
     electronic equivalent of covers if the Document is in electronic
     form.  Otherwise they must appear on printed covers that bracket
     the whole aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License, and all the license notices in the
     Document, and any Warranty Disclaimers, provided that you also
     include the original English version of this License and the
     original versions of those notices and disclaimers.  In case of a
     disagreement between the translation and the original version of
     this License or a notice or disclaimer, the original version will
     prevail.

     If a section in the Document is Entitled "Acknowledgements",
     "Dedications", or "History", the requirement (section 4) to
     Preserve its Title (section 1) will typically require changing the
     actual title.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense, or distribute it is void,
     and will automatically terminate your rights under this License.

     However, if you cease all violation of this License, then your
     license from a particular copyright holder is reinstated (a)
     provisionally, unless and until the copyright holder explicitly and
     finally terminates your license, and (b) permanently, if the
     copyright holder fails to notify you of the violation by some
     reasonable means prior to 60 days after the cessation.

     Moreover, your license from a particular copyright holder is
     reinstated permanently if the copyright holder notifies you of the
     violation by some reasonable means, this is the first time you have
     received notice of violation of this License (for any work) from
     that copyright holder, and you cure the violation prior to 30 days
     after your receipt of the notice.

     Termination of your rights under this section does not terminate
     the licenses of parties who have received copies or rights from you
     under this License.  If your rights have been terminated and not
     permanently reinstated, receipt of a copy of some or all of the
     same material does not give you any rights to use it.

  10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     <http://www.gnu.org/copyleft/>.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If the
     Document does not specify a version number of this License, you may
     choose any version ever published (not as a draft) by the Free
     Software Foundation.  If the Document specifies that a proxy can
     decide which future versions of this License can be used, that
     proxy's public statement of acceptance of a version permanently
     authorizes you to choose that version for the Document.

  11. RELICENSING

     "Massive Multiauthor Collaboration Site" (or "MMC Site") means any
     World Wide Web server that publishes copyrightable works and also
     provides prominent facilities for anybody to edit those works.  A
     public wiki that anybody can edit is an example of such a server.
     A "Massive Multiauthor Collaboration" (or "MMC") contained in the
     site means any set of copyrightable works thus published on the MMC
     site.

     "CC-BY-SA" means the Creative Commons Attribution-Share Alike 3.0
     license published by Creative Commons Corporation, a not-for-profit
     corporation with a principal place of business in San Francisco,
     California, as well as future copyleft versions of that license
     published by that same organization.

     "Incorporate" means to publish or republish a Document, in whole or
     in part, as part of another Document.

     An MMC is "eligible for relicensing" if it is licensed under this
     License, and if all works that were first published under this
     License somewhere other than this MMC, and subsequently
     incorporated in whole or in part into the MMC, (1) had no cover
     texts or invariant sections, and (2) were thus incorporated prior
     to November 1, 2008.

     The operator of an MMC Site may republish an MMC contained in the
     site under CC-BY-SA on the same site at any time before August 1,
     2009, provided the MMC is eligible for relicensing.

ADDENDUM: How to use this License for your documents
====================================================

To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.3
       or any later version published by the Free Software Foundation;
       with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
       Texts.  A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have Invariant Sections, Front-Cover Texts and Back-Cover
Texts, replace the "with...Texts."  line with this:

         with the Invariant Sections being LIST THEIR TITLES, with
         the Front-Cover Texts being LIST, and with the Back-Cover Texts
         being LIST.

   If you have Invariant Sections without Cover Texts, or some other
combination of the three, merge those two alternatives to suit the
situation.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of free
software license, such as the GNU General Public License, to permit
their use in free software.

Concept Index
*************

This is a general index of all issues discussed in this manual